## mygui 3.2.0

=== CMakeLists.txt ===
######################################################################
# MYGUI BUILD SYSTEM
# Welcome to the CMake build system for MYGUI.
# This is the main file where we prepare the general build environment
# and provide build configuration options.
######################################################################

cmake_minimum_required(VERSION 2.6)
set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS TRUE)
cmake_policy(SET CMP0003 NEW)

project(MYGUI)

# Include necessary submodules
set(CMAKE_MODULE_PATH
	"${MYGUI_SOURCE_DIR}/CMake"
	"${MYGUI_SOURCE_DIR}/CMake/Utils"
	"${MYGUI_SOURCE_DIR}/CMake/Packages"
)
include(CMakeDependentOption)
include(MacroLogFeature)
include(MyGUIConfigTargets)
include(PreprocessorUtils)
set(MYGUI_TEMPLATES_DIR "${MYGUI_SOURCE_DIR}/CMake/Templates")
set(MYGUI_WORK_DIR ${MYGUI_BINARY_DIR})


#####################################################################
# Set up the basic build environment
#####################################################################

if (CMAKE_BUILD_TYPE STREQUAL "")
	# CMake defaults to leaving CMAKE_BUILD_TYPE empty. This screws up
	# differentiation between debug and release builds.
	set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Choose the type of build, options are: None (CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif ()

# determine MyGUI version numbers
include(MyGUIGetVersion)
mygui_get_version(${MYGUI_SOURCE_DIR}/MyGUIEngine/include/MyGUI_Prerequest.h)
message(STATUS "Configuring MYGUI ${MYGUI_VERSION}")

if (NOT APPLE)
	# Create debug libraries with _d postfix
	set(CMAKE_DEBUG_POSTFIX "_d")
endif ()

if (CMAKE_COMPILER_IS_GNUCXX)
	# Test for GCC visibility
	include(CheckCXXCompilerFlag)
	check_cxx_compiler_flag(-fvisibility=hidden MYGUI_GCC_VISIBILITY)
	if (MYGUI_GCC_VISIBILITY)
		# determine gcc version
		execute_process(COMMAND ${CMAKE_CXX_COMPILER} -dumpversion OUTPUT_VARIABLE MYGUI_GCC_VERSION)
		message(STATUS "Detected g++ ${MYGUI_GCC_VERSION}")
		message(STATUS "Enabling GCC visibility flags")
		set(MYGUI_GCC_VISIBILITY_FLAGS "-DMYGUI_GCC_VISIBILITY -fvisibility=hidden")

		# check if we can safely add -fvisibility-inlines-hidden
		string(TOLOWER "${CMAKE_BUILD_TYPE}" MYGUI_BUILD_TYPE)
		if (MYGUI_BUILD_TYPE STREQUAL "debug")
			if(MYGUI_GCC_VERSION VERSION_LESS "4.2")
				message(STATUS "Skipping -fvisibility-inlines-hidden due to possible bug in g++ < 4.2")
			else() # double if because of bug in CMake 2.6
				set(MYGUI_GCC_VISIBILITY_FLAGS "${MYGUI_GCC_VISIBILITY_FLAGS} -fvisibility-inlines-hidden")
			endif()
		else ()
			set(MYGUI_GCC_VISIBILITY_FLAGS "${MYGUI_GCC_VISIBILITY_FLAGS} -fvisibility-inlines-hidden")
		endif ()
	endif (MYGUI_GCC_VISIBILITY)

	# Fix x64 issues on Linux
	if("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "x86_64" AND NOT APPLE)
		add_definitions(-fPIC)
	endif()  
endif (CMAKE_COMPILER_IS_GNUCXX)

# determine system endianess
include(TestBigEndian)
test_big_endian(MYGUI_TEST_BIG_ENDIAN)

# Add MyGUIEngine include path

# definitions for samples
set(MYGUI_LIBRARIES MyGUIEngine)

# Specify build paths
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${MYGUI_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${MYGUI_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${MYGUI_BINARY_DIR}/bin)
if (WIN32 OR APPLE)
	if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
		if (UNIX)
			# On Mac OS X and Linux, standard behavior is to install to /usr/local/lib
			set(CMAKE_INSTALL_PREFIX "/usr/local")
		elseif (WIN32)
			# On Windows, we don't want to install in default system location, install is really for the SDK, so call it that
			SET(CMAKE_INSTALL_PREFIX
				"${MYGUI_BINARY_DIR}/sdk" CACHE PATH "MYGUI install prefix" FORCE
			)
		endif ()
	endif (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
endif(WIN32 OR APPLE)

######################################################################
# Provide user options to customise the build process
######################################################################

# Customise what to build
option(MYGUI_STATIC "Static build" FALSE)
option(MYGUI_USE_FREETYPE "Use freetype for font rendering" TRUE)
option(MYGUI_DONT_USE_OBSOLETE "Remove obsole functions from build" FALSE)
option(MYGUI_RTTI_DISABLE_TYPE_INFO "Don't use C++ rtti, use strings instead" FALSE)

set(MYGUI_RENDERSYSTEM 2 CACHE STRING
"Specify the Render System. Possible values:
  1 - Direct3D 9
  2 - Ogre
  3 - OpenGL
  4 - Direct3D 11"
)

option(MYGUI_BUILD_DEMOS "Build MyGUI demos" TRUE)
option(MYGUI_BUILD_PLUGINS "Build MyGUI plugins" TRUE)
option(MYGUI_BUILD_TOOLS "Build the tools" TRUE)
option(MYGUI_BUILD_UNITTESTS "Build the unit tests" FALSE)
option(MYGUI_BUILD_TEST_APP "Build TestApp" FALSE)
option(MYGUI_BUILD_WRAPPER "Build the wrapper" FALSE)

option(MYGUI_INSTALL_SAMPLES "Install MyGUI demos." FALSE)
option(MYGUI_INSTALL_TOOLS "Install MyGUI tools." FALSE)
option(MYGUI_INSTALL_DOCS "Install documentation." FALSE)
option(MYGUI_INSTALL_MEDIA "Install media files." FALSE)
option(MYGUI_INSTALL_SAMPLES_SOURCE "Install samples source files." FALSE)
cmake_dependent_option(MYGUI_INSTALL_PDB "Install debug pdb files" FALSE "MSVC" FALSE)
option(MYGUI_FULL_RPATH "Build executables with the full required RPATH to run from their install location." FALSE)
option(MYGUI_STANDALONE_BUILD "Generate build files that do not reference CMake (should be used only from Scripts/prepareRelease.py)" FALSE)
MARK_AS_ADVANCED(MYGUI_STANDALONE_BUILD)

if (WIN32)
	set(MYGUI_SAMPLES_INPUT 2 CACHE STRING
	"Specify the Input Manager for samples. Possible values:
	  1 - OIS
	  2 - Win32
	  3 - Win32 (Mouse) + OIS (Keyboard)"
	)
else()
	set(MYGUI_SAMPLES_INPUT 1)
endif()

if (MSVC)
	option(MYGUI_USE_PROJECT_FOLDERS "Use Visual Studio solution folders for projects." FALSE)
endif ()

# Used to not annoy users with high level warnings (should be TRUE for developers)
option(MYGUI_HIGH_LEVEL_WARNINGS "Use high level compiler warnings. Developers should enable this." FALSE)
if (MSVC)
	option(MYGUI_CHECK_MEMORY_LEAKS "Check memory leaks. Developers should enable this." FALSE)
endif ()

if (MYGUI_USE_PROJECT_FOLDERS)
	SET_PROPERTY(GLOBAL PROPERTY USE_FOLDERS ON)
endif ()

# Global defines
if (MYGUI_CHECK_MEMORY_LEAKS)
	add_definitions(-DMYGUI_CHECK_MEMORY_LEAKS)
endif ()

if (MYGUI_DONT_USE_OBSOLETE)
	add_definitions(-DMYGUI_DONT_USE_OBSOLETE)
endif ()

if (MYGUI_RTTI_DISABLE_TYPE_INFO)
	add_definitions(-DMYGUI_RTTI_DISABLE_TYPE_INFO)
endif ()
# End of Global defines

# Set compiler specific build flags
if (CMAKE_COMPILER_IS_GNUCXX)
	add_definitions(-msse)
	if (NOT MYGUI_HIGH_LEVEL_WARNINGS)
		add_definitions(-w)
	else ()
		if (MYGUI_RENDERSYSTEM EQUAL 2)
			# to avoid warnings from OGRE
			add_definitions(-isystem ${OGRE_INCLUDE_DIR})
		endif ()
		if (MYGUI_SAMPLES_INPUT EQUAL 1 OR MYGUI_SAMPLES_INPUT EQUAL 3)
			# to avoid warnings from OIS
			add_definitions(-isystem ${OIS_INCLUDE_DIR})
		endif ()
		if (NOT APPLE)
			add_definitions(-fdiagnostics-show-option)
		endif ()
		# very interesting option, but way too many warnings
		#add_definitions(-Weffc++)
		add_definitions(-Wno-deprecated -Wall -Wctor-dtor-privacy -Winit-self -Woverloaded-virtual -Wcast-qual -Wwrite-strings -Wextra -Wno-unused-parameter)
		add_definitions(-pedantic)

		# MyGUI_UString.h ignored from warnings because of this
		add_definitions(-Wshadow)
	endif ()
endif ()

if (MSVC)
	add_definitions(/fp:fast)
	add_definitions("-D_CRT_SECURE_NO_WARNINGS")
	
	# Use the highest warning level for visual studio.
	if (MYGUI_HIGH_LEVEL_WARNINGS)
		SET(WARNING_LEVEL "/W4")
		# disable: warning C4100: '***' : unreferenced formal parameter
		add_definitions(/wd4100)
		# disable: warning C4127: conditional expression is constant
		add_definitions(/wd4127)
		# disable: warning C4512: '***' : assignment operator could not be generated
		add_definitions(/wd4512)
	else ()
		SET(WARNING_LEVEL "/W3")
	endif ()

	if (CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
		STRING(REGEX REPLACE "/W[0-4]" "${WARNING_LEVEL}" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
	else ()
		SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${WARNING_LEVEL}")
	endif ()

endif ()

# Find dependencies
include(Dependencies)

cmake_dependent_option(MYGUI_BUILD_DOCS "Generate documentation" TRUE "DOXYGEN_FOUND" FALSE)

# global configs
include_directories(
	${MYGUI_SOURCE_DIR}/MyGUIEngine/include
)

###################################################################
# configure global build settings based on selected build options
###################################################################
include(ConfigureBuild)


##################################################################
# Now setup targets
##################################################################

# install resource files
include(InstallResources)

# Setup MyGUIEngine project
add_subdirectory(MyGUIEngine)

# Setup Platforms
add_subdirectory(Platforms)

if (MYGUI_BUILD_DEMOS OR MYGUI_BUILD_TOOLS OR MYGUI_BUILD_UNITTESTS OR MYGUI_BUILD_TEST_APP)
	add_subdirectory(Common)
endif ()

# Setup Plugins
if (MYGUI_BUILD_PLUGINS)
	add_subdirectory(Plugins)
endif ()

if (MYGUI_BUILD_DEMOS)
	add_subdirectory(Demos)
endif ()

# Setup command-line tools
if (MYGUI_BUILD_TOOLS)
	add_subdirectory(Tools)
endif ()

# Setup tests
if (MYGUI_BUILD_UNITTESTS OR MYGUI_BUILD_TEST_APP)
	add_subdirectory(UnitTests)
endif ()

# Setup wrapers
if (MYGUI_BUILD_WRAPPER)
	add_subdirectory(Wrappers)
endif ()

# Install documentation
if (MYGUI_BUILD_DOCS)
	add_subdirectory(Docs)
endif ()

# Install media files
if (MYGUI_INSTALL_MEDIA)
	add_subdirectory(Media)
endif ()

# Install CMake modules
add_subdirectory(CMake)

# Provide CPack packaging target
include(Packaging)

=== CMake/CMakeLists.txt ===
#############################################################
# Install useful CMake modules.
# These are necessary to compile the samples from the install
# directory, but can also be used for custom projects.
#############################################################

if(WIN32)
	set(MYGUI_CMAKE_DIR "CMake")
else(WIN32)
	set(MYGUI_CMAKE_DIR "lib/MYGUI/cmake")
endif(WIN32)

set(INST_FILES
  Packages/FindOIS.cmake
  Packages/FindOGRE.cmake
  Utils/FindPkgMacros.cmake
  Utils/PreprocessorUtils.cmake
  Utils/MyGUIConfigTargets.cmake
  Utils/MyGUIGetVersion.cmake
  Utils/MyGUIFindFrameworks.cmake
  Templates/VisualStudioUserFile.vcproj.user.in
  Templates/VisualStudio2010UserFile.vcxproj.user.in
) 
set(STATIC_INST_FILES
  Packages/FindDirectX.cmake
  Packages/FindDirectX11.cmake
  Packages/FindFreetype.cmake
)
if (APPLE)
  set(INST_FILES ${INST_FILES}
    Packages/FindIOKit.cmake
  )
  set(STATIC_INST_FILES ${STATIC_INST_FILES}
    Packages/FindCarbon.cmake
    Packages/FindCocoa.cmake
  )
endif ()

#install(FILES ${INST_FILES} DESTINATION ${MYGUI_CMAKE_DIR})
if (MYGUI_STATIC)
  install(FILES ${STATIC_INST_FILES} DESTINATION ${MYGUI_CMAKE_DIR})
endif ()

=== Common/CMakeLists.txt ===
function(mygui_add_base_manager_source PLATFORM)
	include_directories(Base/${PLATFORM})
	set (HEADER_FILES ${HEADER_FILES} Base/${PLATFORM}/BaseManager.h PARENT_SCOPE)
	set (SOURCE_FILES ${SOURCE_FILES} Base/${PLATFORM}/BaseManager.cpp PARENT_SCOPE)
	SOURCE_GROUP("Base" FILES
		Base/${PLATFORM}/BaseManager.h
		Base/${PLATFORM}/BaseManager.cpp
	)
endfunction(mygui_add_base_manager_source)

function(mygui_add_input_source PLATFORM)
	include_directories(Input/${PLATFORM})
	set (HEADER_FILES ${HEADER_FILES}
		Input/${PLATFORM}/InputManager.h
		Input/${PLATFORM}/PointerManager.h
		PARENT_SCOPE)
	set (SOURCE_FILES ${SOURCE_FILES}
		Input/${PLATFORM}/InputManager.cpp
		Input/${PLATFORM}/PointerManager.cpp
		PARENT_SCOPE)
	SOURCE_GROUP("Base" FILES
		Input/${PLATFORM}/InputManager.h
		Input/${PLATFORM}/InputManager.cpp
		Input/${PLATFORM}/PointerManager.h
		Input/${PLATFORM}/PointerManager.cpp
	)
endfunction(mygui_add_input_source)

set (PROJECTNAME Common)

include_directories(
	.
	${MYGUI_SOURCE_DIR}/Common
	${MYGUI_SOURCE_DIR}/MyGUIEngine/include
)

set (HEADER_FILES "")
set (SOURCE_FILES "")

if(MYGUI_RENDERSYSTEM EQUAL 1)
	mygui_add_base_manager_source(DirectX)
	add_definitions("-DMYGUI_DIRECTX_PLATFORM")
	include_directories(
		${MYGUI_SOURCE_DIR}/Platforms/DirectX/DirectXPlatform/include
		${DirectX_INCLUDE_DIR}
	)
	link_directories(${DIRECTX_LIB_DIR})
elseif(MYGUI_RENDERSYSTEM EQUAL 2)
	mygui_add_base_manager_source(Ogre)
	add_definitions("-DMYGUI_OGRE_PLATFORM")
	include_directories(
		${MYGUI_SOURCE_DIR}/Platforms/Ogre/OgrePlatform/include
		${OGRE_INCLUDE_DIR}
	)
	link_directories(${OGRE_LIB_DIR})
elseif(MYGUI_RENDERSYSTEM EQUAL 3)
	mygui_add_base_manager_source(OpenGL)
	add_definitions("-DMYGUI_OPENGL_PLATFORM")
	include_directories(
		${MYGUI_SOURCE_DIR}/Platforms/OpenGL/OpenGLPlatform/include
		${OPENGL_INCLUDE_DIR}
	)
	link_directories(${OPENGL_LIB_DIR})
elseif(MYGUI_RENDERSYSTEM EQUAL 4)
	mygui_add_base_manager_source(DirectX11)
	add_definitions("-DMYGUI_DIRECTX11_PLATFORM")
	include_directories(
		${MYGUI_SOURCE_DIR}/Platforms/DirectX11/DirectX11Platform/include
		${DirectX_INCLUDE_DIR}
	)
	link_directories(${DIRECTX_LIB_DIR})
endif()

if(MYGUI_SAMPLES_INPUT EQUAL 1)
	include_directories(${OIS_INCLUDE_DIRS})
	mygui_add_input_source(OIS)
elseif(MYGUI_SAMPLES_INPUT EQUAL 2)
	mygui_add_input_source(Win32)
elseif(MYGUI_SAMPLES_INPUT EQUAL 3)
	include_directories(${OIS_INCLUDE_DIRS})
	mygui_add_input_source(Win32_OIS)
endif()

add_library(${PROJECTNAME} ${HEADER_FILES} ${SOURCE_FILES})

if(MYGUI_RENDERSYSTEM EQUAL 1)
	add_dependencies(${PROJECTNAME} MyGUI.DirectXPlatform)
	target_link_libraries(${PROJECTNAME} MyGUI.DirectXPlatform)
elseif(MYGUI_RENDERSYSTEM EQUAL 2)
	add_dependencies(${PROJECTNAME} MyGUI.OgrePlatform)
	target_link_libraries(${PROJECTNAME} MyGUI.OgrePlatform)
elseif(MYGUI_RENDERSYSTEM EQUAL 3)
	add_dependencies(${PROJECTNAME} MyGUI.OpenGLPlatform)
	target_link_libraries(${PROJECTNAME} MyGUI.OpenGLPlatform)
elseif(MYGUI_RENDERSYSTEM EQUAL 4)
	add_dependencies(${PROJECTNAME} MyGUI.DirectX11Platform)
	target_link_libraries(${PROJECTNAME} MyGUI.DirectX11Platform)
endif()

add_dependencies(${PROJECTNAME} MyGUIEngine)

if(MYGUI_SAMPLES_INPUT EQUAL 1)
	add_definitions("-DMYGUI_SAMPLES_INPUT_OIS")
	link_directories(${OIS_LIB_DIR})
	target_link_libraries(${PROJECTNAME} ${OIS_LIBRARIES})
elseif(MYGUI_SAMPLES_INPUT EQUAL 2)
	add_definitions("-DMYGUI_SAMPLES_INPUT_WIN32")
elseif(MYGUI_SAMPLES_INPUT EQUAL 3)
	add_definitions("-DMYGUI_SAMPLES_INPUT_WIN32_OIS")
	link_directories(${OIS_LIB_DIR})
	target_link_libraries(${PROJECTNAME} ${OIS_LIBRARIES})
endif()

=== MyGUIEngine/CMakeLists.txt ===
set (PROJECTNAME MyGUIEngine)

project( ${PROJECTNAME} )

include(PrecompiledHeader)

include(${PROJECTNAME}.list)

include_directories(include)
if (MYGUI_USE_FREETYPE)
	include_directories(
		${FREETYPE_INCLUDE_DIRS} ${FREETYPE_FT2BUILD_INCLUDE_DIR}
	)
	add_definitions(-DMYGUI_USE_FREETYPE)
endif ()

# Get Svn revision
MACRO(Subversion_GET_REVISION variable)
	FIND_PROGRAM(SVN_EXECUTABLE svnversion
		DOC "subversion command line client")

	EXECUTE_PROCESS(
		COMMAND ${SVN_EXECUTABLE} ${MYGUI_SOURCE_DIR}
		OUTPUT_STRIP_TRAILING_WHITESPACE
		OUTPUT_VARIABLE ${variable})
	#MESSAGE(STATUS  ${MYGUI_SOURCE_DIR} ${variable})
ENDMACRO(Subversion_GET_REVISION)

Subversion_GET_REVISION(ProjectRevision)
if (NOT "${ProjectRevision}" STREQUAL "")
	add_definitions(-DMYGUI_SVN_REVISION="${ProjectRevision}")
	MESSAGE(STATUS "Using svn revision ${ProjectRevision}.")
else ()
	MESSAGE(STATUS "Unknown svn revision. It won't be included into build.")
endif ()

add_definitions(-DMYGUI_BUILD)

if (MSVC)
	# disable: "no suitable definition provided for explicit template instantiation request"
	# Occurs for no justifiable reason on all #includes of Singleton
	add_definitions(/wd4661)
endif ()

# setup MyGUIEngine target
add_library(${PROJECTNAME} ${MYGUI_LIB_TYPE} ${HEADER_FILES} ${SOURCE_FILES})
set_target_properties(${PROJECTNAME} PROPERTIES VERSION ${MYGUI_VERSION} SOVERSION ${MYGUI_VERSION_MAJOR})
if (MYGUI_USE_FREETYPE)
	target_link_libraries(${PROJECTNAME}
		${FREETYPE_LIBRARIES}
	)
endif()

# platform specific dependencies
if (APPLE)
	include_directories(/usr/local/include /usr/include)
	target_link_libraries(${PROJECTNAME} ${Carbon_LIBRARY})
endif ()

# specify a precompiled header to use
use_precompiled_header(${PROJECTNAME}
  "${CMAKE_CURRENT_SOURCE_DIR}/include/MyGUI_Precompiled.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/src/MyGUI_Precompiled.cpp"
)

set(${PROJECTNAME}_HEADERS ${HEADER_FILES}) # for Mac OS X
mygui_config_lib(${PROJECTNAME})

# link Carbon on Mac OS X
if (APPLE)
	find_library(CARBON_LIBRARY Carbon)
	target_link_libraries(${PROJECTNAME} ${CARBON_LIBRARY})
endif ()

# install MyGUIEngine headers
install(FILES ${HEADER_FILES}
  DESTINATION include/MYGUI
)

=== Platforms/CMakeLists.txt ===
if(MYGUI_RENDERSYSTEM EQUAL 1)
  add_subdirectory(DirectX/DirectXPlatform)
elseif(MYGUI_RENDERSYSTEM EQUAL 2)
  add_subdirectory(Ogre/OgrePlatform)
elseif(MYGUI_RENDERSYSTEM EQUAL 3)
  add_subdirectory(OpenGL/OpenGLPlatform)
elseif(MYGUI_RENDERSYSTEM EQUAL 4)
  add_subdirectory(DirectX11/DirectX11Platform)
endif()

=== Tools/CMakeLists.txt ===
add_subdirectory(FontViewer)
add_subdirectory(ImageSetViewer)
add_subdirectory(LayoutEditor)
add_subdirectory(SkinEditor)

=== UnitTests/CMakeLists.txt ===
if (MYGUI_BUILD_TEST_APP)
	add_subdirectory(TestApp)
endif ()
if (MYGUI_BUILD_UNITTESTS)
	add_subdirectory(UnitTest_AttachDetach)
	add_subdirectory(UnitTest_ChildAttach)
	#add_subdirectory(UnitTest_Canvas)
	#add_subdirectory(UnitTest_Containers)
	add_subdirectory(UnitTest_Delegates)
	if (MYGUI_RENDERSYSTEM EQUAL 2)
		add_subdirectory(UnitTest_GraphView)
	endif ()
	add_subdirectory(UnitTest_ItemBox_Info)
	add_subdirectory(UnitTest_Layers)
	add_subdirectory(UnitTest_MultiList)
	add_subdirectory(UnitTest_RotatingSkin)
	add_subdirectory(UnitTest_RTTLayer)
	add_subdirectory(UnitTest_Spline)
	add_subdirectory(UnitTest_TextureAnimations)
	add_subdirectory(UnitTest_TreeControl)
endif ()

=== Wrappers/CMakeLists.txt ===
add_subdirectory(WrapperGenerator)
add_subdirectory(MyGUI.RenderWindow.Export)
add_subdirectory(MyGUI.OgrePlatform.Export)

=== Demos/Demo_Controllers/CMakeLists.txt ===
mygui_demo(Demo_Controllers)

=== Demos/Demo_PluginStrangeButton/CMakeLists.txt ===
include_directories(${MYGUI_SOURCE_DIR}/Plugins/Plugin_StrangeButton)
mygui_demo(Demo_PluginStrangeButton)
add_dependencies(Demo_PluginStrangeButton Plugin_StrangeButton)
target_link_libraries(Demo_PluginStrangeButton Plugin_StrangeButton)

=== Plugins/Plugin_BerkeliumWidget/CMakeLists.txt ===
function(mygui_plugin_berkelium PROJECTNAME)
	include_directories(.)
	
	# define the sources
	include(${PROJECTNAME}.list)
	
	include_directories(${BERKELIUM_INCLUDE_DIRS})
	
	add_definitions("-D_USRDLL -DMYGUI_BUILD_DLL")
	add_library(${PROJECTNAME} ${MYGUI_LIB_TYPE} ${HEADER_FILES} ${SOURCE_FILES})
	set_target_properties(${PROJECTNAME} PROPERTIES FOLDER "Plugins")
	add_dependencies(${PROJECTNAME} MyGUIEngine)
	target_link_libraries(${PROJECTNAME} MyGUIEngine)
	target_link_libraries(${PROJECTNAME} ${BERKELIUM_LIBRARIES})
	
	link_directories(${BERKELIUM_LIBRARY_DIRS})
	
	mygui_config_lib(${PROJECTNAME})
	
	install(FILES ${HEADER_FILES}
		DESTINATION include/MYGUI
	)
endfunction(mygui_plugin_berkelium)


mygui_plugin_berkelium(Plugin_BerkeliumWidget)

=== Tools/FontViewer/CMakeLists.txt ===
mygui_tool(FontViewer)

=== debian/changelog ===
mygui (3.2.0-5) unstable; urgency=medium

  [ Bret Curtis ]
  * Build against libogre 1.9 (Closes: #732724)

 -- Bret Curtis <psi29a@gmail.com>  Fri, 03 Jan 2014 08:20:00 +0100

mygui (3.2.0-4) unstable; urgency=medium

  [ Peter Michael Green ]
  * Adjust cmake stuff for new freetype. (Closes: #732969)
  * Build-depend on jessie version of freetype since it's not clear exactly
    when the location was changed.

  [ Scott Howard ]
  * Updated Vcs-Browser
  * moved maintainer to Bret Curtis <psi29a@gmail.com>, made myself uploader

 -- Scott Howard <showard@debian.org>  Mon, 23 Dec 2013 12:20:00 -0500

mygui (3.2.0-3) unstable; urgency=low

  * Build against libogre 1.8 (Closes: #705010)
  * Added Bret Curtis to uploaders

 -- Scott Howard <showard@debian.org>  Fri, 26 Apr 2013 23:03:43 -0400

mygui (3.2.0-2) unstable; urgency=low

  * debian/patches/disable_sse.patch. Disabled -msse flag. Only on
    x86 processors, *i386 need to support processors without it, *64
    architecture has -msse2 as default flag.

 -- Scott Howard <showard@debian.org>  Mon, 08 Apr 2013 08:27:17 -0400

mygui (3.2.0-1) unstable; urgency=low

  * Initial release (Closes: #578690)

 -- Scott Howard <showard@debian.org>  Sat, 19 Jan 2013 14:58:42 -0500

=== debian/control ===
Source: mygui
Priority: optional
Maintainer: Bret Curtis <psi29a@gmail.com>
Uploaders: Scott Howard <showard@debian.org>
Build-Depends: cmake, doxygen, debhelper (>= 9), libogre-1.9-dev,
 libfreetype6-dev (>= 2.5.1), libois-dev, pkg-config, graphviz, libglu1-mesa-dev,
 libgl1-mesa-dev, libglew-dev
Homepage: http://www.ogre3d.org/tikiwiki/MyGUI
Standards-Version: 3.9.5
Section: libs
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/mygui.git
Vcs-Git: git://anonscm.debian.org/collab-maint/mygui.git

Package: libmygui-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
 libmyguiengine3 (= ${binary:Version}),
 libmygui.ogreplatform0debian0 (= ${binary:Version}),
 libmygui.openglplatform0debian0 (= ${binary:Version})
Suggests: mygui-doc
Description: Fast, simple and flexible GUI for OpenMW - development files
 MyGUI is a GUI library which aims to be fast, flexible and simple GUIs in C++.
  Features include
    Layout Editor.
    Multicolour text.
    Per pixel cut.
    Changing alpha support for widgets (also in states configuration).
    Interface localisation.
    Fast RTTI for safe casts.
    Tool tips.
    Animated cursors and pictures.
    User xml resources.
    Truetype fonts and fonts from texture.
    Widgets controllers (moving, fading and so on).
    Flexible configuration in xml config file.
    Subskins with tiling, with direct access to texture.
    Possibility to store any data in widgets items.
    Skin themes.
    Wrappers for fast UI development.
    Drag'n'drop. 
 .
 This package contains the headers and static libraries needed to develop
 programs using MyGUI.

Package: libmyguiengine3
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Fast, simple and flexible GUI - shared library
 MyGUI is a GUI library which aims to be fast, flexible and simple GUIs in C++.
  Features include
    Layout Editor.
    Multicolour text.
    Per pixel cut.
    Changing alpha support for widgets (also in states configuration).
    Interface localisation.
    Fast RTTI for safe casts.
    Tool tips.
    Animated cursors and pictures.
    User xml resources.
    Truetype fonts and fonts from texture.
    Widgets controllers (moving, fading and so on).
    Flexible configuration in xml config file.
    Subskins with tiling, with direct access to texture.
    Possibility to store any data in widgets items.
    Skin themes.
    Wrappers for fast UI development.
    Drag'n'drop.
 .
 This package contains the MyGUI runtime engine.

Package: libmyguiengine3-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${misc:Depends}, libmyguiengine3 (= ${binary:Version})
Description: Fast, simple and flexible GUI - debugging symbols
 MyGUI is a GUI library which aims to be fast, flexible and simple GUIs in C++.
  Features include
    Layout Editor.
    Multicolour text.
    Per pixel cut.
    Changing alpha support for widgets (also in states configuration).
    Interface localisation.
    Fast RTTI for safe casts.
    Tool tips.
    Animated cursors and pictures.
    User xml resources.
    Truetype fonts and fonts from texture.
    Widgets controllers (moving, fading and so on).
    Flexible configuration in xml config file.
    Subskins with tiling, with direct access to texture.
    Possibility to store any data in widgets items.
    Skin themes.
    Wrappers for fast UI development.
    Drag'n'drop.
 .
 This package contains the MyGUI runtime engine debugging symbols.

Package: libmygui.ogreplatform0debian0
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Fast, simple and flexible GUI - Ogre interface
 MyGUI is a GUI library which aims to be fast, flexible and simple GUIs in C++.
  Features include
    Layout Editor.
    Multicolour text.
    Per pixel cut.
    Changing alpha support for widgets (also in states configuration).
    Interface localisation.
    Fast RTTI for safe casts.
    Tool tips.
    Animated cursors and pictures.
    User xml resources.
    Truetype fonts and fonts from texture.
    Widgets controllers (moving, fading and so on).
    Flexible configuration in xml config file.
    Subskins with tiling, with direct access to texture.
    Possibility to store any data in widgets items.
    Skin themes.
    Wrappers for fast UI development.
    Drag'n'drop.
 .
 This package contains the MyGUI interface to the Ogre graphics engine.

Package: libmygui.ogreplatform0debian0-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${misc:Depends}, libmygui.ogreplatform0debian0 (= ${binary:Version})
Description: Fast, simple and flexible GUI Ogre - debugging symbols
 MyGUI is a GUI library which aims to be fast, flexible and simple GUIs in C++.
  Features include
    Layout Editor.
    Multicolour text.
    Per pixel cut.
    Changing alpha support for widgets (also in states configuration).
    Interface localisation.
    Fast RTTI for safe casts.
    Tool tips.
    Animated cursors and pictures.
    User xml resources.
    Truetype fonts and fonts from texture.
    Widgets controllers (moving, fading and so on).
    Flexible configuration in xml config file.
    Subskins with tiling, with direct access to texture.
    Possibility to store any data in widgets items.
    Skin themes.
    Wrappers for fast UI development.
    Drag'n'drop.
 .
 This package contains the MyGUI interface to the Ogre graphics engine debugging
 symbols.

Package: libmygui.openglplatform0debian0
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Fast, simple and flexible GUI - OpenGL interface
 MyGUI is a GUI library which aims to be fast, flexible and simple GUIs in C++.
  Features include
    Layout Editor.
    Multicolour text.
    Per pixel cut.
    Changing alpha support for widgets (also in states configuration).
    Interface localisation.
    Fast RTTI for safe casts.
    Tool tips.
    Animated cursors and pictures.
    User xml resources.
    Truetype fonts and fonts from texture.
    Widgets controllers (moving, fading and so on).
    Flexible configuration in xml config file.
    Subskins with tiling, with direct access to texture.
    Possibility to store any data in widgets items.
    Skin themes.
    Wrappers for fast UI development.
    Drag'n'drop.
 .
 This package contains the MyGUI interface for OpenGL.

Package: libmygui.openglplatform0debian0-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${misc:Depends}, libmygui.openglplatform0debian0 (= ${binary:Version})
Description: Fast, simple and flexible GUI OpenGL - debugging symbols
 MyGUI is a GUI library which aims to be fast, flexible and simple GUIs in C++.
  Features include
    Layout Editor.
    Multicolour text.
    Per pixel cut.
    Changing alpha support for widgets (also in states configuration).
    Interface localisation.
    Fast RTTI for safe casts.
    Tool tips.
    Animated cursors and pictures.
    User xml resources.
    Truetype fonts and fonts from texture.
    Widgets controllers (moving, fading and so on).
    Flexible configuration in xml config file.
    Subskins with tiling, with direct access to texture.
    Possibility to store any data in widgets items.
    Skin themes.
    Wrappers for fast UI development.
    Drag'n'drop.
 .
 This package contains the MyGUI interface for OpenGL debugging symbols.

Package: mygui-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: API documentations for MyGUI library
 MyGUI is a GUI library which aims to be fast, flexible and simple GUIs in C++.
  Features include
    Layout Editor.
    Multicolour text.
    Per pixel cut.
    Changing alpha support for widgets (also in states configuration).
    Interface localisation.
    Fast RTTI for safe casts.
    Tool tips.
    Animated cursors and pictures.
    User xml resources.
    Truetype fonts and fonts from texture.
    Widgets controllers (moving, fading and so on).
    Flexible configuration in xml config file.
    Subskins with tiling, with direct access to texture.
    Possibility to store any data in widgets items.
    Skin themes.
    Wrappers for fast UI development.
    Drag'n'drop.
 .
 This package contains the MyGUI API reference for the MyGUIEngine library.

=== debian/rules ===
#!/usr/bin/make -f

DEB_UPSTREAM_VERSION=$(shell dpkg-parsechangelog | sed -rne 's,^Version: ([^+]+).*-.*,\1,p')
#export DH_VERBOSE=1
%:
	dh $@ --parallel

override_dh_auto_configure: debian/mygui-doc.docs
#	Don't autoconfigure, need to build for Ogre and OpenGL

override_dh_auto_install:
	mv $(CURDIR)/debian/tmp2 $(CURDIR)/debian/tmp

override_dh_auto_build:
#	build for OpenGL
	dh_auto_configure -- -DMYGUI_BUILD_DEMOS=FALSE -DMYGUI_RENDERSYSTEM=3 \
	 -DMYGUI_BUILD_DOCS=FALSE -DMYGUI_BUILD_PLUGINS=FALSE \
	 -DMYGUI_BUILD_TOOLS=FALSE
	dh_auto_build
	${MAKE} install -C obj-$(DEB_BUILD_GNU_TYPE) DESTDIR=$(CURDIR)/debian/tmp2
#	Build for Ogre platform, and tools
	dh_auto_configure -- -DMYGUI_BUILD_DEMOS=FALSE -DMYGUI_RENDERSYSTEM=2 \
	 -DMYGUI_BUILD_DOCS=TRUE -DMYGUI_BUILD_PLUGINS=FALSE \
	 -DMYGUI_BUILD_TOOLS=FALSE
	dh_auto_build
	${MAKE} install -C obj-$(DEB_BUILD_GNU_TYPE) DESTDIR=$(CURDIR)/debian/tmp2

override_dh_install:
	cd obj-$(DEB_BUILD_GNU_TYPE)/Docs && doxygen Doxyfile && cd $(CURDIR)
	find debian/ -type d -empty -delete
	dh_install -Xlicense.txt -Xttf

debian/%.docs: debian/%.docs.in
	sed 's/@BUILD_DIR@/obj-$(DEB_BUILD_GNU_TYPE)/g' $< > $@

override_dh_strip:
	dh_strip -plibmyguiengine3 --dbg-package=libmyguiengine3-dbg
	dh_strip -plibmygui.ogreplatform0debian0 --dbg-package=libmygui.ogreplatform0debian0-dbg
	dh_strip -plibmygui.openglplatform0debian0 --dbg-package=libmygui.openglplatform0debian0-dbg
	dh_strip

override_dh_makeshlibs:
	dh_makeshlibs -V -- -c0 -v$(DEB_UPSTREAM_VERSION)

copyright_check:
	${MAKE} -f /usr/share/cdbs/1/rules/utils.mk debian/stamp-copyright-check
	rm debian/stamp-copyright-check

get-orig-source:
	uscan --download-current-version --repack --rename --verbose

=== debian/watch ===
version=3
http://sf.net/my-gui/MyGUI_([\d\.]*)\.zip

## mygui 3.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -110,14 +110,15 @@
 option(MYGUI_STATIC "Static build" FALSE)
 option(MYGUI_USE_FREETYPE "Use freetype for font rendering" TRUE)
 option(MYGUI_DONT_USE_OBSOLETE "Remove obsole functions from build" FALSE)
-option(MYGUI_RTTI_DISABLE_TYPE_INFO "Don't use C++ rtti, use strings instead" FALSE)
-
-set(MYGUI_RENDERSYSTEM 2 CACHE STRING
+
+set(MYGUI_RENDERSYSTEM 3 CACHE STRING
 "Specify the Render System. Possible values:
-  1 - Direct3D 9
-  2 - Ogre
-  3 - OpenGL
-  4 - Direct3D 11"
+  1 - Dummy
+  2 - Export (latter)
+  3 - Ogre
+  4 - OpenGL
+  5 - Direct3D 9
+  6 - Direct3D 11"
 )
 
 option(MYGUI_BUILD_DEMOS "Build MyGUI demos" TRUE)
@@ -136,6 +137,7 @@
 option(MYGUI_FULL_RPATH "Build executables with the full required RPATH to run from their install location." FALSE)
 option(MYGUI_STANDALONE_BUILD "Generate build files that do not reference CMake (should be used only from Scripts/prepareRelease.py)" FALSE)
 MARK_AS_ADVANCED(MYGUI_STANDALONE_BUILD)
+option(MYGUI_GENERATE_LIST_FILES_FROM_VSPROJECT "Generate .list files from visual studio project files" FALSE)
 
 if (WIN32)
 	set(MYGUI_SAMPLES_INPUT 2 CACHE STRING
@@ -170,41 +172,35 @@
 if (MYGUI_DONT_USE_OBSOLETE)
 	add_definitions(-DMYGUI_DONT_USE_OBSOLETE)
 endif ()
-
-if (MYGUI_RTTI_DISABLE_TYPE_INFO)
-	add_definitions(-DMYGUI_RTTI_DISABLE_TYPE_INFO)
-endif ()
 # End of Global defines
 
 # Set compiler specific build flags
 if (CMAKE_COMPILER_IS_GNUCXX)
-	add_definitions(-msse)
 	if (NOT MYGUI_HIGH_LEVEL_WARNINGS)
-		add_definitions(-w)
+		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -w")
 	else ()
-		if (MYGUI_RENDERSYSTEM EQUAL 2)
+		if (MYGUI_RENDERSYSTEM EQUAL 3)
 			# to avoid warnings from OGRE
-			add_definitions(-isystem ${OGRE_INCLUDE_DIR})
+			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -isystem ${OGRE_INCLUDE_DIR}")
 		endif ()
 		if (MYGUI_SAMPLES_INPUT EQUAL 1 OR MYGUI_SAMPLES_INPUT EQUAL 3)
 			# to avoid warnings from OIS
-			add_definitions(-isystem ${OIS_INCLUDE_DIR})
+			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -isystem ${OIS_INCLUDE_DIR}")
 		endif ()
 		if (NOT APPLE)
-			add_definitions(-fdiagnostics-show-option)
+			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fdiagnostics-show-option")
 		endif ()
 		# very interesting option, but way too many warnings
 		#add_definitions(-Weffc++)
-		add_definitions(-Wno-deprecated -Wall -Wctor-dtor-privacy -Winit-self -Woverloaded-virtual -Wcast-qual -Wwrite-strings -Wextra -Wno-unused-parameter)
-		add_definitions(-pedantic)
+		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated -Wall -Wctor-dtor-privacy -Winit-self -Woverloaded-virtual -Wcast-qual -Wwrite-strings -Wextra -Wno-unused-parameter")
+		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic")
 
 		# MyGUI_UString.h ignored from warnings because of this
-		add_definitions(-Wshadow)
+		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wshadow")
 	endif ()
 endif ()
 
 if (MSVC)
-	add_definitions(/fp:fast)
 	add_definitions("-D_CRT_SECURE_NO_WARNINGS")
 	
 	# Use the highest warning level for visual studio.

=== Common/CMakeLists.txt ===
--- 
+++ 
@@ -38,6 +38,29 @@
 set (SOURCE_FILES "")
 
 if(MYGUI_RENDERSYSTEM EQUAL 1)
+	mygui_add_base_manager_source(Dummy)
+	add_definitions("-DMYGUI_DUMMY_PLATFORM")
+	include_directories(
+		${MYGUI_SOURCE_DIR}/Platforms/Dummy/DummyPlatform/include
+	)
+	link_directories(${DUMMY_LIB_DIR})
+elseif(MYGUI_RENDERSYSTEM EQUAL 3)
+	mygui_add_base_manager_source(Ogre)
+	add_definitions("-DMYGUI_OGRE_PLATFORM")
+	include_directories(
+		${MYGUI_SOURCE_DIR}/Platforms/Ogre/OgrePlatform/include
+		${OGRE_INCLUDE_DIR}
+	)
+	link_directories(${OGRE_LIB_DIR})
+elseif(MYGUI_RENDERSYSTEM EQUAL 4)
+	mygui_add_base_manager_source(OpenGL)
+	add_definitions("-DMYGUI_OPENGL_PLATFORM")
+	include_directories(
+		${MYGUI_SOURCE_DIR}/Platforms/OpenGL/OpenGLPlatform/include
+		${OPENGL_INCLUDE_DIR}
+	)
+	link_directories(${OPENGL_LIB_DIR})
+elseif(MYGUI_RENDERSYSTEM EQUAL 5)
 	mygui_add_base_manager_source(DirectX)
 	add_definitions("-DMYGUI_DIRECTX_PLATFORM")
 	include_directories(
@@ -45,23 +68,7 @@
 		${DirectX_INCLUDE_DIR}
 	)
 	link_directories(${DIRECTX_LIB_DIR})
-elseif(MYGUI_RENDERSYSTEM EQUAL 2)
-	mygui_add_base_manager_source(Ogre)
-	add_definitions("-DMYGUI_OGRE_PLATFORM")
-	include_directories(
-		${MYGUI_SOURCE_DIR}/Platforms/Ogre/OgrePlatform/include
-		${OGRE_INCLUDE_DIR}
-	)
-	link_directories(${OGRE_LIB_DIR})
-elseif(MYGUI_RENDERSYSTEM EQUAL 3)
-	mygui_add_base_manager_source(OpenGL)
-	add_definitions("-DMYGUI_OPENGL_PLATFORM")
-	include_directories(
-		${MYGUI_SOURCE_DIR}/Platforms/OpenGL/OpenGLPlatform/include
-		${OPENGL_INCLUDE_DIR}
-	)
-	link_directories(${OPENGL_LIB_DIR})
-elseif(MYGUI_RENDERSYSTEM EQUAL 4)
+elseif(MYGUI_RENDERSYSTEM EQUAL 6)
 	mygui_add_base_manager_source(DirectX11)
 	add_definitions("-DMYGUI_DIRECTX11_PLATFORM")
 	include_directories(
@@ -84,15 +91,18 @@
 add_library(${PROJECTNAME} ${HEADER_FILES} ${SOURCE_FILES})
 
 if(MYGUI_RENDERSYSTEM EQUAL 1)
+	add_dependencies(${PROJECTNAME} MyGUI.DummyPlatform)
+	target_link_libraries(${PROJECTNAME} MyGUI.DummyPlatform)
+elseif(MYGUI_RENDERSYSTEM EQUAL 3)
+	add_dependencies(${PROJECTNAME} MyGUI.OgrePlatform)
+	target_link_libraries(${PROJECTNAME} MyGUI.OgrePlatform)
+elseif(MYGUI_RENDERSYSTEM EQUAL 4)
+	add_dependencies(${PROJECTNAME} MyGUI.OpenGLPlatform)
+	target_link_libraries(${PROJECTNAME} MyGUI.OpenGLPlatform)
+elseif(MYGUI_RENDERSYSTEM EQUAL 5)
 	add_dependencies(${PROJECTNAME} MyGUI.DirectXPlatform)
 	target_link_libraries(${PROJECTNAME} MyGUI.DirectXPlatform)
-elseif(MYGUI_RENDERSYSTEM EQUAL 2)
-	add_dependencies(${PROJECTNAME} MyGUI.OgrePlatform)
-	target_link_libraries(${PROJECTNAME} MyGUI.OgrePlatform)
-elseif(MYGUI_RENDERSYSTEM EQUAL 3)
-	add_dependencies(${PROJECTNAME} MyGUI.OpenGLPlatform)
-	target_link_libraries(${PROJECTNAME} MyGUI.OpenGLPlatform)
-elseif(MYGUI_RENDERSYSTEM EQUAL 4)
+elseif(MYGUI_RENDERSYSTEM EQUAL 6)
 	add_dependencies(${PROJECTNAME} MyGUI.DirectX11Platform)
 	target_link_libraries(${PROJECTNAME} MyGUI.DirectX11Platform)
 endif()
@@ -110,3 +120,7 @@
 	link_directories(${OIS_LIB_DIR})
 	target_link_libraries(${PROJECTNAME} ${OIS_LIBRARIES})
 endif()
+
+if(NOT WIN32)
+	target_link_libraries(${PROJECTNAME} X11)
+endif()

=== Tools/EditorFramework/CMakeLists.txt ===
mygui_tool_dll(EditorFramework)

=== UnitTests/UnitTest_ItemBox_Info/CMakeLists.txt ===
mygui_unit_test(UnitTest_ItemBox_Info)

=== Platforms/Dummy/DummyPlatform/CMakeLists.txt ===
set (PROJECTNAME MyGUI.DummyPlatform)

include_directories(
	include
	${MYGUI_SOURCE_DIR}/MyGUIEngine/include
	${MYGUI_SOURCE_DIR}/Common
)

include(${PROJECTNAME}.list)

add_library(${PROJECTNAME} ${HEADER_FILES} ${SOURCE_FILES})

add_dependencies(${PROJECTNAME} MyGUIEngine)

=== debian/changelog ===
mygui (3.2.1-1) unstable; urgency=medium

  [ Bret Curtis ]
  * Updated license for majority of files from LGPL to Expat (MIT)

  [ Scott Howard ]
  * New upstream release
  * Updated patch to add build option for system GLEW libraries
  * All patches accepted upstream except shared_libraries.patch
  * Bumped SONAME due to dropped symbols, updated *.symbols and package
    names
  * Updated license of debian/* to Expat with permission of all authors
  * Don't install Doxygen autogenerated md5 and map files (thanks
    lintian)

 -- Scott Howard <showard@debian.org>  Thu, 18 Sep 2014 17:57:48 -0400

mygui (3.2.0-7) unstable; urgency=medium

  * Added limits.patch to fix building on hurd.
  * Updated symbols for libs, this was not done during the automatic rebuild
    triggered by an Ogre3D rebuild.

 -- Bret Curtis <psi29a@gmail.com>  Thu, 07 Aug 2014 08:21:00 +0100

mygui (3.2.0-6) unstable; urgency=low

  * Drop B-D on libois-dev, not used in build
  * link OgrePlatform with libboost_system, fixes unresolved symbols
  * updated shared_libraries.patch
    - LINK_INTERFACE_LIBRARIES set in MyGUI target to not use
      transitive library depends
    - OPENGL_LIBRARIES links to x11 and GLU. Changed to link to GL
      instead.
  * Updated symbols file

 -- Scott Howard <showard@debian.org>  Thu, 16 Jan 2014 14:54:12 -0500

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,7 @@
 Maintainer: Bret Curtis <psi29a@gmail.com>
 Uploaders: Scott Howard <showard@debian.org>
 Build-Depends: cmake, doxygen, debhelper (>= 9), libogre-1.9-dev,
- libfreetype6-dev (>= 2.5.1), libois-dev, pkg-config, graphviz, libglu1-mesa-dev,
- libgl1-mesa-dev, libglew-dev
+ libfreetype6-dev (>= 2.5.1), pkg-config, graphviz, libgl1-mesa-dev, libglew-dev
 Homepage: http://www.ogre3d.org/tikiwiki/MyGUI
 Standards-Version: 3.9.5
 Section: libs
@@ -15,9 +14,9 @@
 Section: libdevel
 Architecture: any
 Depends: ${misc:Depends},
- libmyguiengine3 (= ${binary:Version}),
- libmygui.ogreplatform0debian0 (= ${binary:Version}),
- libmygui.openglplatform0debian0 (= ${binary:Version})
+ libmyguiengine3debian1 (= ${binary:Version}),
+ libmygui.ogreplatform0debian1 (= ${binary:Version}),
+ libmygui.openglplatform0debian1 (= ${binary:Version})
 Suggests: mygui-doc
 Description: Fast, simple and flexible GUI for OpenMW - development files
  MyGUI is a GUI library which aims to be fast, flexible and simple GUIs in C++.
@@ -43,7 +42,7 @@
  This package contains the headers and static libraries needed to develop
  programs using MyGUI.
 
-Package: libmyguiengine3
+Package: libmyguiengine3debian1
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Fast, simple and flexible GUI - shared library
@@ -69,11 +68,11 @@
  .
  This package contains the MyGUI runtime engine.
 
-Package: libmyguiengine3-dbg
+Package: libmyguiengine3debian1-dbg
 Architecture: any
 Section: debug
 Priority: extra
-Depends: ${misc:Depends}, libmyguiengine3 (= ${binary:Version})
+Depends: ${misc:Depends}, libmyguiengine3debian1 (= ${binary:Version})
 Description: Fast, simple and flexible GUI - debugging symbols
  MyGUI is a GUI library which aims to be fast, flexible and simple GUIs in C++.
   Features include
@@ -97,7 +96,7 @@
  .
  This package contains the MyGUI runtime engine debugging symbols.
 
-Package: libmygui.ogreplatform0debian0
+Package: libmygui.ogreplatform0debian1
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Fast, simple and flexible GUI - Ogre interface
@@ -123,11 +122,11 @@
  .
  This package contains the MyGUI interface to the Ogre graphics engine.
 
-Package: libmygui.ogreplatform0debian0-dbg
+Package: libmygui.ogreplatform0debian1-dbg
 Architecture: any
 Section: debug
 Priority: extra
-Depends: ${misc:Depends}, libmygui.ogreplatform0debian0 (= ${binary:Version})
+Depends: ${misc:Depends}, libmygui.ogreplatform0debian1 (= ${binary:Version})
 Description: Fast, simple and flexible GUI Ogre - debugging symbols
  MyGUI is a GUI library which aims to be fast, flexible and simple GUIs in C++.
   Features include
@@ -152,7 +151,7 @@
  This package contains the MyGUI interface to the Ogre graphics engine debugging
  symbols.
 
-Package: libmygui.openglplatform0debian0
+Package: libmygui.openglplatform0debian1
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Fast, simple and flexible GUI - OpenGL interface
@@ -178,11 +177,11 @@
  .
  This package contains the MyGUI interface for OpenGL.
 
-Package: libmygui.openglplatform0debian0-dbg
+Package: libmygui.openglplatform0debian1-dbg
 Architecture: any
 Section: debug
 Priority: extra
-Depends: ${misc:Depends}, libmygui.openglplatform0debian0 (= ${binary:Version})
+Depends: ${misc:Depends}, libmygui.openglplatform0debian1 (= ${binary:Version})
 Description: Fast, simple and flexible GUI OpenGL - debugging symbols
  MyGUI is a GUI library which aims to be fast, flexible and simple GUIs in C++.
   Features include

=== debian/rules ===
--- 
+++ 
@@ -13,13 +13,13 @@
 
 override_dh_auto_build:
 #	build for OpenGL
-	dh_auto_configure -- -DMYGUI_BUILD_DEMOS=FALSE -DMYGUI_RENDERSYSTEM=3 \
+	dh_auto_configure -- -DMYGUI_BUILD_DEMOS=FALSE -DMYGUI_RENDERSYSTEM=4 \
 	 -DMYGUI_BUILD_DOCS=FALSE -DMYGUI_BUILD_PLUGINS=FALSE \
-	 -DMYGUI_BUILD_TOOLS=FALSE
+	 -DMYGUI_BUILD_TOOLS=FALSE -DMYGUI_USE_SYSTEM_GLEW=TRUE
 	dh_auto_build
 	${MAKE} install -C obj-$(DEB_BUILD_GNU_TYPE) DESTDIR=$(CURDIR)/debian/tmp2
 #	Build for Ogre platform, and tools
-	dh_auto_configure -- -DMYGUI_BUILD_DEMOS=FALSE -DMYGUI_RENDERSYSTEM=2 \
+	dh_auto_configure -- -DMYGUI_BUILD_DEMOS=FALSE -DMYGUI_RENDERSYSTEM=3 \
 	 -DMYGUI_BUILD_DOCS=TRUE -DMYGUI_BUILD_PLUGINS=FALSE \
 	 -DMYGUI_BUILD_TOOLS=FALSE
 	dh_auto_build
@@ -30,13 +30,16 @@
 	find debian/ -type d -empty -delete
 	dh_install -Xlicense.txt -Xttf
 
+override_dh_installdocs:
+	dh_installdocs -X.md5 -X.map
+
 debian/%.docs: debian/%.docs.in
 	sed 's/@BUILD_DIR@/obj-$(DEB_BUILD_GNU_TYPE)/g' $< > $@
 
 override_dh_strip:
-	dh_strip -plibmyguiengine3 --dbg-package=libmyguiengine3-dbg
-	dh_strip -plibmygui.ogreplatform0debian0 --dbg-package=libmygui.ogreplatform0debian0-dbg
-	dh_strip -plibmygui.openglplatform0debian0 --dbg-package=libmygui.openglplatform0debian0-dbg
+	dh_strip -plibmyguiengine3debian1 --dbg-package=libmyguiengine3debian1-dbg
+	dh_strip -plibmygui.ogreplatform0debian1 --dbg-package=libmygui.ogreplatform0debian1-dbg
+	dh_strip -plibmygui.openglplatform0debian1 --dbg-package=libmygui.openglplatform0debian1-dbg
 	dh_strip
 
 override_dh_makeshlibs:
